from tkinter import *
import math, time,random
NX=51;NY=51#XY方向のセル数
CSIZE=8    #セルのサイズ
Alfa=0.95  #フェロモンの減衰定数
NANT=20    #蟻の数
FOOD=[[5,40], [40,45],[10,20],[35,10]]#餌の位置
def array(N1, N2=0,N3=0):   #■配列宣言
    if N2==0: return [0 for i in range(N1)]
    if N3==0: return [[0 for i in range(N2)]
                      for j in range(N1)]
    return[[[0 for i in range(N3)]for j in range(N2)]
           for k in range(N1)]
def initSpace(N1,N2):return array(N1,N2)#■蟻行動スペース
def setNest(S):#■蟻の巣の位置の設定
    N1=len(S);N2=len(S[0])
    X=int(N1/2);Y=int(N2/2); return [X,Y]
def initDraw(canvas,S):#■蟻行動スペースの初期描画
    global CSIZE
    N1=len(S);N2=len(S[0]); dID=initSpace(N1,N2)
    for i in range(N1):
        X=i*CSIZE+20
        for j in range(N2):
            Y=j*CSIZE+20
            dID[i][j]=canvas.create_rectangle(X,Y,X+CSIZE,Y+CSIZE,
                                              fill="#FFFFFF")
    return dID
def setCL(R):
    if R>255:return 255
    return int(R)
def RGB(R,G,B):#■RGB設定
    return "#%02X%02X%02X" %(setCL(R),setCL(G),setCL(B))
def setColor(V):#■蟻行動スペースの色設定
    if V>=1:return "#FF0000"
    if V>0.5: return RGB(255,int((1-V)*511),0)
    return RGB(255,255,int(1-V)*255)
def drawSpace(canvas,dID,S,Ant):#■蟻行動スペースの描画
    N1=len(S);N2=len(S[0])
    for i in range(N1):
        for j in range(N2):
            V=S[i][j]
            if   V==-1:CL="#0000FF"   #巣の位置の色
            elif V==-2:CL="#00FF00"   #餌の位置の色
            else:CL=setColor(S[i][j]) #その他の位置の色
            canvas.itemconfig(dID[i][j],fill=CL)#色変更
    for k in range(len(Ant)):#画面上の蟻位置表示
        i=Ant[k][0];j=Ant[k][1]
        canvas.itemconfig(dID[i][j],fill="black")
def setNestToSpace(S,nestXY):#■巣の位置を反映
    S[nestXY[0]][nestXY[1]]=-1
    return S
def defuse(S,alf):#■フェロモンの減衰
    N1=len(S);N2=len(S[0])
    for i in range(N1):
        for j in range(N2):
            if S[i][j]>0:#巣，餌の位置を無視
                S[i][j]*=alf
                if S[i][j]<=0.1: S[i][j]=0
    return S
def genAnt(nestXY,N):#■蟻集団の生成
    R=array(N,4)
    for i in range(N):
        R[i][0]=nestXY[0];R[i][1]=nestXY[1]
    return R
def initDrawAnt(canvas, dID,Ant):#■蟻集団の初期描画
    for k in range(len(Ant)):
        i=Ant[k][0];j=Ant[k][1]
        canvas.itemconfig(dID[i][j],fill="black")        
moveAntTab=[[-1,-1],[-1,0],[-1,1],#■蟻移動表
            [ 0,-1],       [ 0,1],
            [ 1,-1],[ 1,0],[ 1,1]]
def pheromone(S,X,Y,N1,N2):#■フェロモンの知覚
    P=[]
    for i in range(-1,2):
        if (X+i)>=0 and (X+i)<N1:
            for j in range(-1,2):
                if (((Y+j)>=0 and (Y+j)<N2) and
                    (i!=0 or j!=0)):
                    if S[X+i][Y+j]==-2:return []#餌あり
                    if S[X+i][Y+j]>0: P.append([X+i,Y+j])
    return P
def nearFood(i,j,S,Ant,near,N1,N2,PHR):#■近傍の餌
    for k1 in range(-near,near+1):
        for k2 in range(-near,near+1):
            if ((i+k1)>=0 and (i+k1)<N1 and
                (j+k2)>=0 and (j+k2)<N2):  #範囲内
                if S[i+k1][j+k2]==-2:      #餌あり
                    Ant[0]=i+k1;Ant[1]=j+k2
                    Ant[2]=1;return Ant
                if PHR and S[i+k1][j+k2]>0:#フェロモン
                    Ant[0]=i+k1;Ant[1]=j+k2
                    Ant[2]=2;return Ant
    return Ant
def randomMove(Ant,N1,N2):#■一匹の蟻移動(ランダム移動)
    global moveAntTab
    XY=moveAntTab[int(random.random()*8)]
    Ant[0]+=XY[0];Ant[1]+=XY[1]
    if Ant[0]<0:Ant[0]=0
    elif Ant[0]>=N1:Ant[0]=N1-1
    if Ant[1]<0:Ant[1]=0
    elif Ant[1]>=N2:Ant[1]=N2-1
    return Ant
def setDxDy(dx,dy):
    if abs(dx)>=abs(dy):#距離の長いほうを基準にする
        dy=dy/dx;dx=dx/abs(dx)
        if dx<0:dy=-dy
    else:
        dx=dx/dy;dy=dy/abs(dy)
        if dy<0:dx=-dx
    return [dx,dy]
def distantNext(P,nestXY):#■巣から遠い点を選択
    DX=P[0][0]-nestXY[0]; DY=P[0][1]-nestXY[1]
    MX=DX*DX+DY*DY;ID=0;NP=len(P)
    for i in range(1, NP):
        DX=P[i][0]-nestXY[0]; DY=P[i][1]-nestXY[1]
        DD=DX*DX+DY*DY;
        if DD>MX:ID=i;MX=DD
        elif DD==MX and random.random()<0.5:ID=i
    return ID
def moveAnt(S,nestXY, Ant,N1,N2):#■蟻集団の移動
    for k in range(len(Ant)):
        i=Ant[k][0];j=Ant[k][1]
        if Ant[k][2]==0:
            Ant[k]=nearFood(i,j,S,Ant[k],3,N1,N2,True)
        if S[i][j]==-1: Ant[k][2]=0
        if   Ant[k][2]==0:Ant[k]=randomMove(Ant[k],N1,N2)
        elif Ant[k][2]==1:#■餌を見つけた後の帰巣
            X=Ant[k][0]; Y=Ant[k][1]
            dx=nestXY[0]-X;dy=nestXY[1]-Y
            DD=setDxDy(dx,dy);dx=DD[0];dy=DD[1]
            for i in range(5):
                X+=dx;Y+=dy
                if (int(X+0.5)==nestXY[0] and #巣の位置で終わり
                    int(Y+0.5)==nestXY[1]):Ant[k][2]=0; break
                if S[int(X+0.5)][int(Y+0.5)]>=0:
                    S[int(X+0.5)][int(Y+0.5)]+=1 #フェロモンを残す
            Ant[k][0]=int(X+0.5);Ant[k][1]=int(Y+0.5);#蟻の位置
        elif Ant[k][2]==2:#フェロモン感知による移動
            X=Ant[k][0]; Y=Ant[k][1]
            Ant[k]=nearFood(X,Y,S,Ant[k],1,N1,N2,False)#餌位置
            #X=Ant[k][0]; Y=Ant[k][1]
            if S[X][Y]<0:Ant[k][2]=0 # 巣または餌位置で終わり
            elif Ant[k][2]==2:#フェロモン移動
                P=pheromone(S,X,Y,N1,N2);NP=len(P)
                if NP<1: Ant[k][2]=0
                else:#巣から遠い点を選ぶ
                    ID=distantNext(P,nestXY)
                    Ant[k][0]=P[ID][0];Ant[k][1]=P[ID][1]
    return Ant
def setFood(S):#■食物の設定
    global FOOD
    for i in range(len(FOOD)): S[FOOD[i][0]][FOOD[i][1]]=-2
    return S
root=Tk();root.title("Ant Colony")
canvas=Canvas(root,width=500,height=500,bg="white")
canvas.pack();root.update()
S=initSpace(NX,NY);
S=setFood(S)
nestXY=setNest(S)
S=setNestToSpace(S,nestXY)
dID=initDraw(canvas,S)
Ant=genAnt(nestXY,NANT)
initDrawAnt(canvas,dID,Ant)
while True:
    Ant=moveAnt(S,nestXY,Ant,NX,NY)
    drawSpace(canvas,dID,S,Ant)
    S=defuse(S,Alfa)
    root.update()
    time.sleep(0.001)
    
    





